/*

The NetUsage Project
http://netusage.mozdev.org/

Copyright (C) 2005, NetUsage Project
This extension can be freely distributed under
the terms of the Mozilla Public Licence 1.1
See the licence at http://www.mozilla.org/MPL/

---------
NetUsage ToolItem

*/

// TODO regexp modifier . match new ln - but /s doesn't work!

const nuISPNormal = 1;
const nuISPRelax = 2;

const nuISPAuthPost = 1;
const nuISPAuthGet = 2;
const nuISPAuthBasic = 3;
const nuISPAuthCustom = 4;
const nuISPAuthCookie = 5;
const nuISPAuthCookieGet = 6;

var nuSupportedISPs = {
'bigpond': 'Bigpond Broadband',
'netspace': 'Netspace ADSL',
'iinetb2': 'iiBroadband2 ADSL',
'iinet': 'iiNet bliink ADSL',
'internode': 'Internode',
'optus': 'OptusNet Broadband',
'aanet': 'aaNet ADSL',
'exetel': 'eXeTeL ADSL',
'exetelwireless': 'eXeTeL Wireless',
'pacnet': 'Pacific Internet',
//'globaldial': 'Global Dial',
'tpgi': 'TPG Internet',
//'iprimus': 'iPrimus Broadband',
'unwired': 'Unwired',
'adam': 'Adam Internet',
//'veritel': 'Veritel',
//'grapevine': 'Grapevine',
'arachnet': 'Arachnet',
'onthenet': 'OntheNet',
'netcall': '.Netcall',
'westnet': 'WestNet',

//canada
//'shaw': 'Shaw',
//'videotron': 'Videotron',

// NZ
'xtranz': 'Xtra Broadband',

//india
//'hathway': 'Hathway',

// potugal
'netcabo': 'Net cabo',
//'sapo': 'Sapo',
//'cabovisao': 'cabovisao',

//Belgium
'coditel': 'Coditel.net',
}

function nuFillISPInterface(isp) {

	var month3l = {'Jan': 0, 'Feb': 1, 'Mar': 2, 'Apr': 3, 'May': 4, 'Jun': 5, 'Jul': 6, 'Aug': 7, 'Sep': 8, 'Oct': 9, 'Nov': 10, 'Dec': 11};


	switch(isp) {
	case 'bigpond':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: '',
			mode: nuISPRelax,
			url: 'https://account.bigpond.com/siteminderagent/nocert/{TIMESTAMP}/smgetcred.scc?TYPE=16777217&REALM=$SM$Toolbar&TARGET=$SM$https%3a%2f%2faccount%2ebigpond%2ecom%2fbroadband%2fusage%2ftoolbar%2ftoolbar%2edo?version=1.4',
			urlAuth: nuISPAuthBasic,

			usagePageUrl: 'https://telstra.com/siteminderagent/login/bdumcustlogin.fcc?TYPE=33554432&REALMOID=&GUID=&SMAUTHREASON=0&TARGET=$SM$https://telstra.com/tcoma/security/login2-sm.asp%3fform=bdumcust_,_AUTH_REDIR=https://account.bigpond.com/broadband/usage/secure/monthlyusage.do',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'username={USERNAME}&password={PASSWORD}',

			strToInt: function (m, s) {
				// bigpond 10GB "unlimited" plan is actually -1 MB ?!
				i = parseInt(s, 10);
				if (i == -1 && m == 'qt') i = 10000;
				return i;
			},

			xpVerify: '/bigpond[@version="1.4"]/usage/account',

			//xpUpload: '/bigpond/usage/account/upload',
			xpBalance: '/bigpond/usage/account/balance',
			xpLimit: '/bigpond/usage/account/limit',

			//xpRecorded: '/bigpond/usage/account/recorded'
		}
	case 'netspace':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: '',
			mode: nuISPNormal,
			url: 'https://usage.netspace.net.au/usage-meter/adslusage?version=2&granularity=MONTH',
			urlAuth: nuISPAuthBasic,

			usagePageUrl: 'https://my.netspace.net.au/usage-meter/',
			usagePageAuth: nuISPAuthBasic,
			usagePageAuthRealm: 'myNetspace',

			xpError: '/opt/@ERROR',

			xpVerify: '/USAGE[@VERSION="2"]/TRAFFIC',
			xpPlanName: '/USAGE/PLAN/@DESCRIPTION',

			xpStartDate: '/USAGE/@START_DATE',
			xpEndDate: '/USAGE/@END_DATE',

			//xpUpload: '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Standard"]/@UPLOADS',
			//xpDownload: '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Standard"]/@DOWNLOADS',
			//xpLimit: '/USAGE/PLAN/LIMIT[@NAME="Standard"]/@MEGABYTES',
			xpUpload: '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Peak"]/@UPLOADS',
			xpDownload: '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Peak"]/@DOWNLOADS',
			xpLimit: '/USAGE/PLAN/LIMIT[@NAME="Peak"]/@MEGABYTES',

			//xpUploadF: '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Standard"]/@UPLOADS',
			//xpDownloadF: '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Standard"]/@DOWNLOADS',
			xpUploadF: '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Peak"]/@UPLOADS',
			xpDownloadF: '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Peak"]/@DOWNLOADS',

			xpUploadP: '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Peak"]/@UPLOADS',
			xpDownloadP: '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Peak"]/@DOWNLOADS',
			xpLimitP: '/USAGE/PLAN/LIMIT[@NAME="Peak"]/@MEGABYTES',
			xpUploadPO: '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Off Peak"]/@UPLOADS',
			xpDownloadPO: '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Off Peak"]/@DOWNLOADS',
			xpLimitPO: '/USAGE/PLAN/LIMIT[@NAME="Off Peak"]/@MEGABYTES',

			xpUploadFP: '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Peak"]/@UPLOADS',
			xpDownloadFP: '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Peak"]/@DOWNLOADS',
			xpUploadFPO: '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Off Peak"]/@UPLOADS',
			xpDownloadFPO: '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Off Peak"]/@DOWNLOADS',

		}
	case 'iinet':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: '',
			mode: nuISPNormal,
			url: 'https://toolbox.iinet.net.au/cgi-bin/volumegraphs.cgi',
			urlAuth: nuISPAuthPost,
			urlAuthPostData: 'action=login&username={USERNAME}&password={PASSWORD}',

			usagePageUrl: 'https://toolbox.iinet.net.au/cgi-bin/volumegraphs.cgi',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'action=login&username={USERNAME}&password={PASSWORD}',

			regexp1P: / ([0-9]+) MB Peak time, ([0-9]+) MB [Bb]liinktime[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A>[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A><\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<\/TR>[\n\r ]+<TR ALIGN=right BGCOLOR=#ebebff>[\n\r ]+<TD>&nbsp;<\/TD>[\n\r ]+<TD ALIGN=left><B>Total<\/B><\/TD>[\n\r ]+<TD><B>&nbsp;<\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>/,
			regexpErr: /Please enter your Username and Password/,

			iPlanName: 0,

			iStartDate: 3,
			iEndDate: 4,

			iUploadP: 0,
			iDownloadP: 5,
			iLimitP: 1,
			iUploadPO: 0,
			iDownloadPO: 7,
			iLimitPO: 2,

			iUploadF: 0,
			iDownloadF: 6,
			iDownloadFP: 6,
		}
	case 'iinetb2':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: '',
			mode: nuISPNormal,
			url: 'https://toolbox.iinet.net.au/cgi-bin/volumegraphs.cgi',
			urlAuth: nuISPAuthPost,
			urlAuthPostData: 'action=login&username={USERNAME}&password={PASSWORD}',

			usagePageUrl: 'https://toolbox.iinet.net.au/cgi-bin/volumegraphs.cgi',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'action=login&username={USERNAME}&password={PASSWORD}',

			regexp1P: / ([0-9]+) MB Peak time, ([0-9]+) MB[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A>[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A><\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<\/TR>[\n\r ]+<TR ALIGN=right BGCOLOR=#ebebff>[\n\r ]+<TD>&nbsp;<\/TD>[\n\r ]+<TD ALIGN=left><B>Total<\/B><\/TD>[\n\r ]+<TD><B>&nbsp;<\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>/,
			regexpErr: /Please enter your Username and Password/,

			iPlanName: 0,

			iStartDate: 3,
			iEndDate: 4,

			iUploadP: 0,
			iDownloadP: 5,
			iLimitP: 1,
			iUploadPO: 0,
			iDownloadPO: 6,
			iLimitPO: 2,

			iUploadF: 0,
			iDownloadF: 7,
			iDownloadFP: 7,
		}

	case 'internode':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: '',
			mode: nuISPNormal,
			url: 'https://accounts.internode.on.net/cgi-bin/padsl-usage',
			urlAuth: nuISPAuthPost,
			urlAuthPostData: 'username={USERNAME}&password={PASSWORD}',

			usagePageUrl: 'https://accounts.internode.on.net/cgi-bin/login',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'username={USERNAME}&password={PASSWORD}&access=Personal_ADSL',

			regexp1: /([0-9\.]+) ([0-9]+) ([0-9\/]+)/,
			regexpErr: /([^\r\n]+)/,

			iPlanName: 0,

			iNextRollDate: 3,

			iUpload: 0,
			iDownload: 1,
			iLimit: 2,
		}
	case 'optus':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: '',
			mode: nuISPNormal,
			url: 'https://memberservices.optusnet.com.au/myusage/usage.txt',
			urlAuth: nuISPAuthPost,
			urlAuthPostData: 'login={USERNAME}&passwd={PASSWORD}',

			usagePageUrl: 'https://memberservices.optusnet.com.au/login/?target=/myusage/',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'Action=login&username={USERNAME}&password={PASSWORD}',

			regexp1P: /end=([0-9\-]+)[^`]+?last=([0-9:\- ]+)[^`]+?offpeak_usage=([0-9]+)MB[^`]+?plan_limit=([0-9]+)MB[^`]+?plan_name=([^\r\n]+)[^`]+?plan_offpeak=([0-9]+)MB[^`]+?start=([0-9\-]+)[^`]+?usage=([0-9]+)MB/,
			regexpErr: /error=1[^`]+?reason=([^\r\n]+)/,

			iPlanName: 5,
			iStartDate: 7,
			iEndDate: 1,

			iUpload: 0,
			iDownload: 0,
			iDownloadF: 0,
			iRecorded: 2,
			iLimit: 0,

			iUploadP: 0,
			iUploadPO: 0,

			iDownloadP: 8,
			iDownloadPO: 3,
			iDownloadFP: 0,
			iDownloadFPO: 0,

			iLimitP: 4,
			iLimitPO: 6,
		}
	case 'swiftdsl':
		return {
			id: isp,
			description: 'Please manually enter your usage quota.',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			urlLogin: 'https://members.swiftdsl.com.au/usage.php',
			url: 'https://members.swiftdsl.com.au/usage.php',
			urlLogout: 'https://members.swiftdsl.com.au/main.php?logout=y',
			urlAuth: nuISPAuthCookie,
			urlAuthPostData: 'username={USERNAME}&password={PASSWORD}',

			usagePageUrl: 'https://members.swiftdsl.com.au/usage.php',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'username={USERNAME}&password={PASSWORD}',


			strToInt: function (m, s) {
				if (m == 'qt') {
					return 16000;
				} else {
					return Math.round(s);
				}
			},

			regexp1P: /<b>([0-9\.]*)<\/b>.*<b>([0-9\.]*)<\/b>.*<b>([0-9\.]*)<\/b>.*<b>([0-9\.]*)<\/b>.*<b>[0-9\.]*<\/b>.*<b>[0-9\.]*<\/b>.*<b>([0-9\.]*)<\/b>.*<b>([0-9\.]*)<\/b>/,
			regexp1: /<b>([0-9\.]*)<\/b>.*<b>([0-9\.]*)<\/b>.*<b>[0-9\.]*<\/b>.*<b>([0-9\.]*)<\/b>/,
			regexpErr: / is invalid Please try again/,

			iPlanName: 0,

			iUpload: 0,
			iDownload: 1,
			iDownloadF: 2,
			iRecorded: 3,
			iLimit: 0,

			iUploadP: 0,
			iUploadPO: 0,

			iDownloadP: 1,
			iDownloadPO: 2,
			iDownloadFP: 3,
			iDownloadFPO: 4,

			iLimitP: 0,
			iLimitPO: 0,
		}
	case 'aanet':
		return {
			id: isp,
			description: 'Please enter phone number enter as username!',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			url: 'https://www.aanet.com.au/usage2.php?{USERNAME},{PASSWORD}',
			urlAuth: nuISPAuthGet,

			usagePageUrl: 'https://www.aanet.com.au/members/checkuser.php',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'username={USERNAME}&password={PASSWORD}&doLogin=1&submit=+Login+',

			strToInt: function (m, s) {
				if (m == 'qt')
					return parseInt(s, 10);
				else
					return Math.round(s/1048576);
			},

			regexp1: /([0-9]+),([0-9]+),([0-9:\- ]+),([0-9]+),([0-9]+),([^,]+),([^,]+)/,
			regexpErr: /([^\r\n]+)/,

			iPlanName: 7,

			iNextRollDay: 4,

			iUpload: 1,
			iDownload: 2,
			iLimit: 5,
			iRecorded: 3,
		}
	case 'exetel':
		return {
			id: isp,
			description: 'Please manually enter your usage quota and start day.',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			urlLogin: 'https://www.exetel.com.au/members/usage_monthly_query.php',
			url: 'https://www.exetel.com.au/members/usage_monthly_query.php',
			urlLogout: 'https://www.exetel.com.au/members/logout.php',
			urlAuth: nuISPAuthCookie,
			urlAuthPostData: 'login_name={USERNAME}&password={PASSWORD}&doLogin=1&submit=+Login+',

			usagePageUrl: 'https://www.exetel.com.au/members/usage_monthly_query.php',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'login_name={USERNAME}&password={PASSWORD}&doLogin=1&submit=+Login+',


			regexp1P: /Total:[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>/,

			regexpErr: /The Service Number and Password you have entered is invalid/,

			iPlanName: 0,

			iUploadP: 3,
			iUploadPO: 1,

			iDownloadP: 4,
			iDownloadPO: 2,
			iDownloadFP: 0,
			iDownloadFPO: 0,

			iLimitP: 0,
			iLimitPO: 0,
		}
	case 'exetelwireless':
		return {
			id: isp,
			description: 'Please manually enter your usage quota and start day.',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			urlLogin: 'https://www.exetel.com.au/wireless_login/usage_monthly_query.php',
			url: 'https://www.exetel.com.au/wireless_login/usage_monthly_query.php',
			urlLogout: 'https://www.exetel.com.au/wireless_login/logout.php',
			urlAuth: nuISPAuthCookie,
			urlAuthPostData: 'login_name={USERNAME}&password={PASSWORD}&doLogin=1&submit=+Login+',

			usagePageUrl: 'https://www.exetel.com.au/wireless_login/usage_monthly_query.php',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'login_name={USERNAME}&password={PASSWORD}&doLogin=1&submit=+Login+',


			regexp1P: /Total:[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>/,

			regexpErr: /The Service Number and Password you have entered is invalid/,

			iPlanName: 0,

			iUploadP: 3,
			iUploadPO: 1,

			iDownloadP: 4,
			iDownloadPO: 2,
			iDownloadFP: 0,
			iDownloadFPO: 0,

			iLimitP: 0,
			iLimitPO: 0,
		}
	case 'pacnet':
		return {
			id: isp,
			description: 'Please manually enter your usage quota.',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			urlLogin: 'https://www.pacific.net.au/account/perform-login.jsp',
			url: 'https://www.pacific.net.au/account/services/trafficviewselector.jsp?pastStr=0&mode=tabular',
			urlLogout: 'https://www.pacific.net.au/account/logout.jsp',
			urlAuth: nuISPAuthCookie,
			urlAuthPostData: 'username={USERNAME}&password={PASSWORD}&realm=pacific.net.au',

			usagePageUrl: 'https://www.pacific.net.au/account/perform-login.jsp',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'username={USERNAME}&password={PASSWORD}&realm=pacific.net.au',



			regexp1: /selected>([\/0-9]+) - ([\/0-9]+)[^`]+href="trafficviewselector\.jsp\?zoom=period">[^`]+right>([0-9\,\.]+)[^`]+right>([0-9,\.]+)/,

			regexpErr: /Invalid username/,

			iPlanName: 0,

			iStartDate: 1,
			iEndDate: 2,

			iUpload: 3,
			//iUploadF: 5,

			iDownload: 4,
			//iDownloadF: 6,

			iLimitP: 0,
			iLimitPO: 0,
		}
	case 'tpgi':
		return {
			id: isp,
			description: 'Please manually enter your usage limit.',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			urlLogin: 'https://cyberstore.tpg.com.au/your_account/index.php',
			url: 'https://cyberstore.tpg.com.au/your_account/index.php?function=checkaccountusage',
			urlLogout: 'https://cyberstore.tpg.com.au/your_account/index.php?function=logout',
			urlAuth: nuISPAuthCookie,
			urlAuthPostData: 'check_username={USERNAME}&password={PASSWORD}&Submit=GO%21',			

			usagePageUrl: 'https://cyberstore.tpg.com.au/your_account/index.php?function=checkaccountusage',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'check_username={USERNAME}&password={PASSWORD}&Submit=GO%21',

			strToDate: function (m, s) {
				//13 Sep 2004
				var a = /([0-9]+) ([A-Za-z]+) ([0-9]+)/.exec(s);
					return new Date(a[3], month3l[a[2]], a[1], 23, 59, 59);
			},

			regexp1: /<b>Package Type:<\/b> ([A-Za-z 0-9\.]+)[^`]+?<b>Download Charges:<\/b> ([A-Za-z0-9 :]+)[^`]+?Expiry Date:<\/b> ([A-Za-z0-9 ]+)[^`]+?Charges: (\$[0-9\.]+)[^`]+?Download used: ([0-9\.]+) MB/,

			regexpErr: /Invalid username or customer ID or password/,

			iPlanName: 1,

			iNextRollDate: 3,

			iDownload: 5,
			//iLimit: 2,
		}
	case 'iprimus':
		return {
			id: isp,
			description: 'Please manually enter your usage quota.',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			urlLogin: 'https://toolbox.iprimus.com.au/verifypwd.asp',
			url: 'https://toolbox.iprimus.com.au/UsageOverall.asp',
			urlLogout: 'https://toolbox.iprimus.com.au/logout.asp',
			urlAuth: nuISPAuthCookie,
			urlAuthPostData: 'Username={USERNAME}&Password={PASSWORD}&URL=%2FUsageOverall.asp&timezoneoffset=-660&submit=Login',

			usagePageUrl: 'https://toolbox.iprimus.com.au/verifypwd.asp',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'Username={USERNAME}&Password={PASSWORD}&URL=%2FUsageOverall.asp&timezoneoffset=-660&submit=Login',

			// this is a potentially dangerous regexp, iprimus page makes it hard for mozilla regexp to parse
			// only essential values are captured to minimize delay
			regexp1: /Period from ([A-Za-z0-9, ]+?) to ([A-Za-z0-9, ]+?)<\/b><\/span>[^\r\n]*[\r\n]+<br><b> Plan name : <\/b> ([A-Za-z0-9 ]+)[\r\n]+[^\r\n]+[\r\n]+[^\r\n]+?clsTableBody">[^\r\n]+?clsTableBody">[^\r\n]+?clsTableBody">([0-9MB\. ]+)[^\r\n]+?clsTableBody">([0-9MB\. ]+)[^\r\n]+?clsTableBody">[^\r\n]+[\r\n]+<\/table><br><br>/,
			//regexp2: /Period from ([A-Za-z0-9, ]+?) to ([A-Za-z0-9, ]+?)<\/b><\/span>[^\r\n]*[\r\n]+<br><b> Plan name : <\/b> ([A-Za-z0-9 ]+)[\r\n]+[^\r\n]+[\r\n]+[^\r\n]+?clsTableBody">[^\r\n]+?clsTableBody">([A-Za-z0-9&; ]+)[^\r\n]+?clsTableBody">([0-9MB\. ]+)[^\r\n]+?clsTableBody">([0-9MB\. ]+)[^\r\n]+?clsTableBody">([^<]+)[^\r\n]+[\r\n]+<\/table><br><br>/,

			regexpErr: /Log in using your username and password/,


			strToDate: function (m, s) {
				//Thursday, 7 October 2004
				var a = /[^,]+, ([0-9]+) ([A-Za-z]+) ([0-9]+)/.exec(s);
					return new Date(a[3], month3l[a[2].substr(0,3)], a[1], 23, 59, 59);
			},


			iPlanName: 3,

			iStartDate: 1,
			iEndDate: 2,

			iUpload: 4,

			iDownload: 5,

			iLimit: 0,

			// re2:
			// total time 4
			// last recorded session 7
		}






	
	case 'unwired':
		return {
			id: isp,
			description: '',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			urlLogin: 'https://www.unwired.com.au/myaccount/login.php?ev=nx',
			url: 'https://www.unwired.com.au/myaccount/usage.php',
			urlLogout: 'https://www.unwired.com.au/myaccount/logout.php',
			urlAuth: nuISPAuthCookie,
			urlAuthPostData: 'login_name={USERNAME}&login_password={PASSWORD}&loginbutton=Login',

			usagePageUrl: 'https://www.unwired.com.au/myaccount/login.php?ev=nx',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'login_name={USERNAME}&login_password={PASSWORD}&loginbutton=Login',

			regexp1: /My current plan is: ([A-Za-z0-9 \/]+)[^`]+?My current usage allowance: ([0-9]+)[^`]+?usage.php">([A-Za-z0-9\-]+) - ([A-Za-z0-9\-]+)[^`]+?Total<\/td>[\r\n 	]+<td>([0-9\.]+)<\/td>[\r\n 	]+<td>([0-9\.]+)/,
			regexpErr: /Login failed/,


			strToDate: function (m, s) {
				//13-Sep-2004
				var a = /([0-9]+)-([A-Za-z]+)-([0-9]+)/.exec(s);
					return new Date(a[3], month3l[a[2]], a[1], 23, 59, 59);
			},
			strToInt: function (m, s) {
				var i = parseInt(s, 10);
				if (m == 'qt')
					return (i < 300) ? i*1000 : i;
				else
					return i;
			},


			iPlanName: 1,

			iStartDate: 3,
			iEndDate: 4,

			iUpload: 5,

			iDownload: 6,

			iLimit: 2,

		}



	case 'adam':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: '',
			mode: nuISPNormal,
			url: 'http://members.adam.com.au/um/usage.xml',
			urlAuth: nuISPAuthBasic,

			usagePageUrl: 'http://members.adam.com.au/',
			usagePageAuth: nuISPAuthBasic,
			usagePageAuthRealm: 'Adam Members Area External Access',

			strToDate: function (m, s) {
				var xpdtar;
				if (m == 'rollday') {
					xpdtar = s.split(/[-\/]/);
					// s 2004/10/25 take day (25)
					return parseInt(xpdtar[2], 10);
				}
			},

			xpVerify: '/response/UsageMeter/Version',

			//xpUpload: '',
			xpDownloadP: '/response/Account/SubAccount/MegabytesDownloadedExternal',
			xpUploadP: '/response/Account/SubAccount/MegabytesUploadedTotal',
			xpLimitP: '/response/Account/MegabyteQuota',
			xpDownloadPO: '/response/Account/SubAccount/MegabytesDownloadedTotal - /response/Account/SubAccount/MegabytesDownloadedExternal',
			xpLimitPO: '/response/Account/MegabyteQuota',
			xpNextRollDay: '/response/Account/QuotaStartDate',
			
			xpRecorded: '/response/Account/LastUpdate'
		}


	case 'arachnet':
		return {
			id: isp,
			description: 'Please manually enter your usage quota and start day.',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,

			getC1: function(isp) {
				// ripped from netusagecom
				var astartdate;
				var aenddate;

				var nowdate = new Date();
				var nowmonth = nowdate.getMonth();
				var nowyear = nowdate.getFullYear();
				// remember: illogical JS has 0 based months
				var daysInMonth = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
				// leap detection
				if (nowyear % 400 == 0 || (nowyear % 4 == 0 && nowyear % 100 != 0)) daysInMonth[1] = 29;

				var startday = isp.overridestartday;
				
				if (startday > 1) {
					// overridestartday

					if (nowdate.getDate() < startday) {
						// last start day in prev month
						astartdate = new Date((nowmonth-1 < 0) ? (nowyear-1) : (nowyear), (nowmonth-1 < 0) ? 12: (nowmonth-1), startday, 0, 0, 0);
						aenddate = new Date(nowyear, nowmonth, startday-1, 23, 59, 59);

					} else {
						// last start day is in this month or today
						astartdate = new Date(nowyear, nowmonth, startday, 0, 0, 0);
						aenddate = new Date((nowmonth+1 > 11) ? (nowyear+1) : (nowyear), (nowmonth+1 > 11) ? 0: (nowmonth+1), startday-1, 23, 59, 59);

					}
				} else {
					// ISP is day1 based
					astartdate = new Date(nowyear, nowmonth, 1, 0, 0, 0);
					aenddate = new Date(nowyear, nowmonth, daysInMonth[nowmonth], 23, 59, 59);

				}
				
				return "startdd="+astartdate.getDate()+"&startmm="+(astartdate.getMonth()+1)+"&startyy="+(astartdate.getFullYear()+"").substr(2)+"&stopdd="+aenddate.getDate()+"&stopmm="+(aenddate.getMonth()+1)+"&stopyy="+(aenddate.getFullYear()+"").substr(2);
			},

			url: 'http://weaver.arach.net.au/cgi-bin/trafficusage/traffic_usage',

			urlAuth: nuISPAuthPost,
			urlAuthPostData: 'username={USERNAME}&password={PASSWORD}&period=Daily&filter=%28None%29&output=Mega+Bytes+%28MB%29&{C1}&I1=Submit+Query',

			usagePageUrl: 'http://weaver.arach.net.au/cgi-bin/trafficusage/traffic_usage',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'username={USERNAME}&password={PASSWORD}',

			regexp1P: /Total \[Peak\][^`]+?<b>([0-9,]+) MB[^`]+?<b>([0-9,]+) MB[^`]+?<b>([0-9,]+) MB[^`]+?<b>([0-9,]+) MB[^`]+?<b>([0-9,]+) MB[^`]+?<b>([0-9,]+) MB[^`]+?Total \[Off-Peak\][^`]+?<b>([0-9,]+) MB[^`]+?<b>([0-9,]+) MB[^`]+?<b>([0-9,]+) MB[^`]+?<b>([0-9,]+) MB[^`]+?<b>([0-9,]+) MB[^`]+?<b>([0-9,]+) MB/,

			regexpErr: /Incorrect username\/password supplied/,

			iPlanName: 0,

			iUploadP: 2,
			iUploadPO: 8,

			iDownloadP: 1,
			iDownloadPO: 7,
			//iDownloadFP: "3+5", unsupported
			//iDownloadFPO: "9+11", unsupported

			iLimitP: 0,
			iLimitPO: 0,
		}

	case 'onthenet':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: '',
			mode: nuISPNormal,

			url: 'http://dslstats.onthenet.com.au/services/usage30day/{USERNAME}',
			urlAuth: nuISPAuthBasic,

			usagePageUrl: 'http://dslstats.onthenet.com.au/services/usage30day/{USERNAME}',
			usagePageAuth: nuISPAuthBasic,

			regexp1P: /Plan -<\/b> ([A-Za-z0-9 \-\/]+)[^`]+?nowrap>[\s]+([0-9]+)[^`]+?nowrap>[\s]+([0-9]+)[^`]+?nowrap>[\s]+([0-9]+)[^`]+?nowrap>[\s]+([0-9]+)[^`]+?[0-9]{4}-[0-9]{2}-([0-9]{2})/,

			iPlanName: 1,

			iUploadP: 0,
			iUploadPO: 0,

			iDownloadP: 3,
			iDownloadPO: 5,

			iLimitP: 2,
			iLimitPO: 4,
			
			iNextRollDay: 6
		}

	case 'netcall':
		return {
			id: isp,
			description: 'Please enter phone number enter as username!',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			url: 'https://www.netcall.com.au/usage2.php?{USERNAME},{PASSWORD}',
			urlAuth: nuISPAuthGet,

			usagePageUrl: 'https://www.netcall.com.au/members.html',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'servicenumber={USERNAME}&password={PASSWORD}',

			strToInt: function (m, s) {
				if (m == 'qt')
					return parseInt(s, 10);
				else
					return Math.round(s/1048576);
			},

			regexp1: /([0-9]+),([0-9]+),([0-9:\- ]+),([0-9]+),([0-9]+),([^,]+),([^,]+)/,
			regexpErr: /([^\r\n]+)/,

			iPlanName: 7,

			iNextRollDay: 4,

			iUpload: 1,
			iDownload: 2,
			iLimit: 5,
			iRecorded: 3,
		}

	case 'westnet':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: '',
			mode: nuISPNormal,
			url: 'https://secure1.wn.com.au/webservices/customer/ADSLUsage/adslxmlusage.asmx/getUsage',
			urlAuth: nuISPAuthPost,
			urlAuthPostData: 'username={USERNAME}&password={PASSWORD}',

			usagePageUrl: 'https://myaccount.westnet.com.au/Login.aspx?ReturnUrl=%2fTechnical%2fUsage%2fDefault.aspx',
			usagePageAuth: nuISPAuthPost,
			usagePageAuthPostData: 'tbUsername={USERNAME}&tbPassword={PASSWORD}',

			regexp1: /<usagelimit>([0-9]+)<\/usagelimit>[^`]*<peakused>([0-9\.,]+)<\/peakused>[^`]*<peakfree>([0-9\.,]+)<\/peakfree>/,
			regexp1P: /<usagelimit>([0-9]+) \/ ([0-9]+)<\/usagelimit>[^`]*<peakused>([0-9\.,]+)<\/peakused>[^`]*<peakfree>([0-9\.,]+)<\/peakfree>[^`]*<offpeakused>([0-9\.,]+)<\/offpeakused>[^`]*<offpeakfree>([0-9\.,]+)<\/offpeakfree>/,

			regexpErr: /xmlns:xsi="http:\/\/www.w3.org\/2001\/XMLSchema-instance" xsi:nil="true"/,

			iPlanName: 0,

			iUpload: 0,
			iDownload: 2,
			iDownloadF: 3,
			iRecorded: 0,
			iLimit: 1,

			iUploadP: 0,
			iUploadPO: 0,

			iDownloadP: 3,
			iDownloadPO: 5,
			iDownloadFP: 4,
			iDownloadFPO: 6,

			iLimitP: 1,
			iLimitPO: 2,
		}





	case 'xtranz':
		return {
			id: isp,
			description: '',
			name: nuSupportedISPs[isp],
			mode: nuISPNormal,
			urlLogin: 'https://www.telecom.co.nz/xtralogin.fcc',
			url: 'https://www.telecom.co.nz/jetstreamum/xtraSum',
			urlLogout: 'https://www.telecom.co.nz/logout.html',
			urlAuth: nuISPAuthCookie,
			urlAuthPostData: 'USER={USERNAME}&PASSWORD={PASSWORD}&SMENC=ISO-8859-1&SMLOCALE=US-EN&target=https://www.telecom.co.nz/jetstreamum/xtraSum&smauthreason=0',

			usagePageUrl: 'https://www.telecom.co.nz/xtralogin.fcc',
			usagePageAuth: nuISPAuthPost,
			urlAuthPostData: 'USER={USERNAME}&PASSWORD={PASSWORD}&SMENC=ISO-8859-1&SMLOCALE=US-EN&target=https://www.telecom.co.nz/jetstreamum/xtraSum&smauthreason=0',

			strToDate: function (m, s) {
				//13 Sep 2004
				var a = /([0-9]+) ([A-Za-z]+) ([0-9]+)/.exec(s);
				if (m == 'start')
					return new Date(a[3], month3l[a[2]], a[1], 0, 0, 0);
				else
					return new Date(a[3], month3l[a[2]], a[1], 23, 59, 59);
			},

			regexp1: /Usage for:<\/td>[^`]+?([A-Za-z 0-9]+)-([A-Za-z 0-9]+)[^`]+?Current usage plan:<\/td>[^`]+?<td>([A-Za-z0-9 ]+)[^`]+?Usage as at[^`]+?<b>([0-9\/ :]+)<\/b>[^`]+?([0-9\.]+) MB<\/nobr>[^`]+?<b>([0-9]+) MB<\/b>/,

			regexpErr: /You have entered an incorrect User Name or password. Please try again./,

			iPlanName: 3,

			iStartDate: 1,
			iEndDate: 2,

			iDownload: 5,
			iLimit: 6,

			iRecorded: 4,
		}



	case 'netcabo':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: 'Please manually enter usage limit. OffPeak=International',
			mode: nuISPRelax,
			url: 'https://clientes.netcabo.pt/netcabo/trafego_m1_taxas.asp',
			urlAuth: nuISPAuthBasic,

			usagePageUrl: 'https://clientes.netcabo.pt/netcabo/trafego_m1_taxas.asp',
			usagePageAuth: nuISPAuthBasic,


			regexp1P: /MBytes Internacionais<\/td>[^`]+?Total<\/td>[^`]+?>([0-9]+)<\/td>[^`]+?([0-9]+)<\/td>/,

			iPlanName: 0,

			iDownloadP: 1,
			iDownloadPO: 2,
			iLimitP: 0,
			iLimitPO: 0,
		}






	case 'coditel':
		return {
			id: isp,
			name: nuSupportedISPs[isp],
			description: 'Please enter the ESN in the username field',
			mode: nuISPRelax,
			url: 'http://www.coditel.net/ENcm_counters.asp?ESN={USERNAME}&action=CheckESN',
			urlAuth: nuISPAuthGet,

			usagePageUrl: 'http://www.coditel.net/ENcm_counters.asp?ESN={USERNAME}&action=CheckESN',
			usagePageAuth: nuISPAuthGet,

			strToInt: function (m, s) {
				if (m == 'qt') {
					return 15000;
				} else {
					// numbers are gigabytes
					// commas are decimal in the page
					d = new Number(s.replace(/,/, '.'));
					return Math.round(d*1000);
				}
			},

			regexp1: /Download used this month : ([0-9,]+) GBytes<br>Upload used this month : ([0-9,]+) GBytes/,

			iPlanName: 0,

			iUpload: 2,
			iDownload: 1,
			iLimit: 0,
		}
	}



	return null;

}
